Share via


Clusters - Create Or Update

Create or update a Kusto cluster.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Kusto/clusters/{clusterName}?api-version=2025-02-14

URI Parameters

Name In Required Type Description
clusterName
path True

string

pattern: ^.*$

The name of the Kusto cluster.

resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string

minLength: 1

The ID of the target subscription.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Header

Name Required Type Description
If-Match

string

The ETag of the cluster. Omit this value to always overwrite the current cluster. Specify the last-seen ETag value to prevent accidentally overwriting concurrent changes.

If-None-Match

string

Set to '*' to allow a new cluster to be created, but to prevent updating an existing cluster. Other values will result in a 412 Pre-condition Failed response.

Request Body

Name Required Type Description
location True

string

The geo-location where the resource lives

sku True

AzureSku

The SKU of the cluster.

identity

Identity

The identity of the cluster, if configured.

properties.acceptedAudiences

AcceptedAudiences[]

The cluster's accepted audiences.

properties.allowedFqdnList

string[]

List of allowed FQDNs(Fully Qualified Domain Name) for egress from Cluster.

properties.allowedIpRangeList

string[]

The list of ips in the format of CIDR allowed to connect to the cluster.

properties.calloutPolicies

CalloutPolicy[]

List of callout policies for egress from Cluster.

properties.enableAutoStop

boolean

A boolean value that indicates if the cluster could be automatically stopped (due to lack of data or no activity for many days).

properties.enableDiskEncryption

boolean

A boolean value that indicates if the cluster's disks are encrypted.

properties.enableDoubleEncryption

boolean

A boolean value that indicates if double encryption is enabled.

properties.enablePurge

boolean

A boolean value that indicates if the purge operations are enabled.

properties.enableStreamingIngest

boolean

A boolean value that indicates if the streaming ingest is enabled.

properties.engineType

EngineType

The engine type

properties.keyVaultProperties

KeyVaultProperties

KeyVault properties for the cluster encryption.

properties.languageExtensions

LanguageExtensionsList

List of the cluster's language extensions.

properties.optimizedAutoscale

OptimizedAutoscale

Optimized auto scale definition.

properties.publicIPType

PublicIPType

Indicates what public IP type to create - IPv4 (default), or DualStack (both IPv4 and IPv6)

properties.publicNetworkAccess

PublicNetworkAccess

Public network access to the cluster is enabled by default. When disabled, only private endpoint connection to the cluster is allowed

properties.restrictOutboundNetworkAccess

ClusterNetworkAccessFlag

Whether or not to restrict outbound network access. Value is optional but if passed in, must be 'Enabled' or 'Disabled'

properties.trustedExternalTenants

TrustedExternalTenant[]

The cluster's external tenants.

properties.virtualClusterGraduationProperties

string (password)

Virtual Cluster graduation properties

properties.virtualNetworkConfiguration

VirtualNetworkConfiguration

Virtual network definition.

tags

object

Resource tags.

zones

string[]

The availability zones.

Responses

Name Type Description
200 OK

Cluster

Resource 'Cluster' update operation succeeded

201 Created

Cluster

Resource 'Cluster' create operation succeeded

Headers

  • Location: string
  • Retry-After: integer
Other Status Codes

ErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

KustoClusterCreateWithCMKFederatedIdentity
KustoClusterCreateWithCMKUserAssignedIdentity
KustoClustersCreateOrUpdate

KustoClusterCreateWithCMKFederatedIdentity

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.Kusto/clusters/kustoClusterCMK?api-version=2025-02-14

{
  "location": "westus",
  "sku": {
    "name": "Standard_L16as_v3",
    "capacity": 2,
    "tier": "Standard"
  },
  "identity": {
    "type": "UserAssigned",
    "userAssignedIdentities": {
      "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity": {}
    }
  },
  "properties": {
    "enableStreamingIngest": true,
    "enablePurge": true,
    "enableDoubleEncryption": false,
    "enableAutoStop": true,
    "publicIPType": "IPv4",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled",
    "keyVaultProperties": {
      "keyVaultUri": "https://myvault.vault.azure.net",
      "keyName": "myClusterCMKKey",
      "keyVersion": "12345678-1234-1234-1234-123456789098",
      "userIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity",
      "federatedIdentityClientId": "11111111-2222-3333-4444-555555555555"
    },
    "engineType": "V3"
  }
}

Sample response

{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.Kusto/Clusters/kustoClusterCMK",
  "name": "kustoClusterCMK",
  "type": "Microsoft.Kusto/Clusters",
  "location": "westus",
  "properties": {
    "provisioningState": "Succeeded",
    "enableDiskEncryption": false,
    "enableStreamingIngest": true,
    "enablePurge": true,
    "enableDoubleEncryption": false,
    "enableAutoStop": true,
    "publicIPType": "IPv4",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled",
    "keyVaultProperties": {
      "keyVaultUri": "https://myvault.vault.azure.net",
      "keyName": "myClusterCMKKey",
      "keyVersion": "12345678-1234-1234-1234-123456789098",
      "userIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity",
      "federatedIdentityClientId": "11111111-2222-3333-4444-555555555555"
    },
    "engineType": "V3"
  },
  "sku": {
    "name": "Standard_L16as_v3",
    "tier": "Standard",
    "capacity": 2
  },
  "identity": {
    "type": "UserAssigned",
    "userAssignedIdentities": {
      "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity": {
        "clientId": "11111111-2222-3333-4444-555555555555",
        "principalId": "66666666-7777-8888-9999-000000000000"
      }
    }
  },
  "etag": "abcd1234"
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/providers/Microsoft.Kusto/locations/westus/operationResults/742bef43-608b-4b58-ba96-6f7a32ec5f0f?api-version=2025-02-14
{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.Kusto/Clusters/kustoClusterCMK",
  "name": "kustoClusterCMK",
  "type": "Microsoft.Kusto/Clusters",
  "location": "westus",
  "properties": {
    "provisioningState": "Running",
    "enableDiskEncryption": false,
    "enableStreamingIngest": true,
    "enablePurge": true,
    "enableDoubleEncryption": false,
    "enableAutoStop": true,
    "publicIPType": "IPv4",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled",
    "keyVaultProperties": {
      "keyVaultUri": "https://myvault.vault.azure.net",
      "keyName": "myClusterCMKKey",
      "keyVersion": "12345678-1234-1234-1234-123456789098",
      "userIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity",
      "federatedIdentityClientId": "11111111-2222-3333-4444-555555555555"
    },
    "engineType": "V3"
  },
  "sku": {
    "name": "Standard_L16as_v3",
    "tier": "Standard",
    "capacity": 2
  },
  "identity": {
    "type": "UserAssigned",
    "userAssignedIdentities": {
      "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity": {
        "clientId": "11111111-2222-3333-4444-555555555555",
        "principalId": "66666666-7777-8888-9999-000000000000"
      }
    }
  },
  "etag": "abcd1234"
}

KustoClusterCreateWithCMKUserAssignedIdentity

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.Kusto/clusters/kustoClusterCMK?api-version=2025-02-14

{
  "location": "westus",
  "sku": {
    "name": "Standard_L16as_v3",
    "capacity": 2,
    "tier": "Standard"
  },
  "identity": {
    "type": "UserAssigned",
    "userAssignedIdentities": {
      "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity": {}
    }
  },
  "properties": {
    "enableStreamingIngest": true,
    "enablePurge": true,
    "enableDoubleEncryption": false,
    "enableAutoStop": true,
    "publicIPType": "IPv4",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled",
    "keyVaultProperties": {
      "keyVaultUri": "https://myvault.vault.azure.net",
      "keyName": "myClusterCMKKey",
      "keyVersion": "12345678-1234-1234-1234-123456789098",
      "userIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity"
    },
    "engineType": "V3"
  }
}

Sample response

{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.Kusto/Clusters/kustoClusterCMK",
  "name": "kustoClusterCMK",
  "type": "Microsoft.Kusto/Clusters",
  "location": "westus",
  "properties": {
    "provisioningState": "Succeeded",
    "enableDiskEncryption": false,
    "enableStreamingIngest": true,
    "enablePurge": true,
    "enableDoubleEncryption": false,
    "enableAutoStop": true,
    "publicIPType": "IPv4",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled",
    "keyVaultProperties": {
      "keyVaultUri": "https://myvault.vault.azure.net",
      "keyName": "myClusterCMKKey",
      "keyVersion": "12345678-1234-1234-1234-123456789098",
      "userIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity"
    },
    "engineType": "V3"
  },
  "sku": {
    "name": "Standard_L16as_v3",
    "tier": "Standard",
    "capacity": 2
  },
  "identity": {
    "type": "UserAssigned",
    "userAssignedIdentities": {
      "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity": {
        "clientId": "11111111-2222-3333-4444-555555555555",
        "principalId": "66666666-7777-8888-9999-000000000000"
      }
    }
  },
  "etag": "abcd1234"
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/providers/Microsoft.Kusto/locations/westus/operationResults/742bef43-608b-4b58-ba96-6f7a32ec5f0f?api-version=2025-02-14
{
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.Kusto/Clusters/kustoClusterCMK",
  "name": "kustoClusterCMK",
  "type": "Microsoft.Kusto/Clusters",
  "location": "westus",
  "properties": {
    "provisioningState": "Running",
    "enableDiskEncryption": false,
    "enableStreamingIngest": true,
    "enablePurge": true,
    "enableDoubleEncryption": false,
    "enableAutoStop": true,
    "publicIPType": "IPv4",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled",
    "keyVaultProperties": {
      "keyVaultUri": "https://myvault.vault.azure.net",
      "keyName": "myClusterCMKKey",
      "keyVersion": "12345678-1234-1234-1234-123456789098",
      "userIdentity": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity"
    },
    "engineType": "V3"
  },
  "sku": {
    "name": "Standard_L16as_v3",
    "tier": "Standard",
    "capacity": 2
  },
  "identity": {
    "type": "UserAssigned",
    "userAssignedIdentities": {
      "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustoRgTest/providers/Microsoft.ManagedIdentity/userAssignedIdentities/kustoClusterIdentity": {
        "clientId": "11111111-2222-3333-4444-555555555555",
        "principalId": "66666666-7777-8888-9999-000000000000"
      }
    }
  },
  "etag": "abcd1234"
}

KustoClustersCreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/clusters/kustoCluster?api-version=2025-02-14

{
  "identity": {
    "type": "SystemAssigned"
  },
  "location": "westus",
  "properties": {
    "allowedIpRangeList": [
      "0.0.0.0/0"
    ],
    "enableAutoStop": true,
    "enableDoubleEncryption": false,
    "enablePurge": true,
    "enableStreamingIngest": true,
    "languageExtensions": {
      "value": [
        {
          "languageExtensionImageName": "Python3_10_8",
          "languageExtensionName": "PYTHON"
        },
        {
          "languageExtensionImageName": "R",
          "languageExtensionName": "R"
        }
      ]
    },
    "publicIPType": "DualStack",
    "publicNetworkAccess": "Enabled"
  },
  "sku": {
    "name": "Standard_L16as_v3",
    "capacity": 2,
    "tier": "Standard"
  }
}

Sample response

{
  "name": "kustoCluster",
  "type": "Microsoft.Kusto/Clusters",
  "etag": "abcd",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster",
  "identity": {
    "type": "SystemAssigned",
    "principalId": "faabad1f-4876-463c-af9d-6ba2d2d2394c",
    "tenantId": "b932977f-6277-4ab7-a2cd-5bd21f07aaf4",
    "userAssignedIdentities": {}
  },
  "location": "westus",
  "properties": {
    "allowedIpRangeList": [
      "0.0.0.0/0"
    ],
    "enableAutoStop": true,
    "enableDiskEncryption": false,
    "enableDoubleEncryption": false,
    "enablePurge": true,
    "enableStreamingIngest": true,
    "engineType": "V3",
    "keyVaultProperties": {
      "keyName": "keyName",
      "keyVaultUri": "https://dummy.keyvault.com",
      "keyVersion": "keyVersion"
    },
    "languageExtensions": {
      "value": [
        {
          "languageExtensionImageName": "Python3_10_8",
          "languageExtensionName": "PYTHON"
        },
        {
          "languageExtensionImageName": "R",
          "languageExtensionName": "R"
        }
      ]
    },
    "provisioningState": "Succeeded",
    "publicIPType": "DualStack",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled"
  },
  "sku": {
    "name": "Standard_L16as_v3",
    "capacity": 2,
    "tier": "Standard"
  }
}
{
  "name": "kustoCluster",
  "type": "Microsoft.Kusto/Clusters",
  "etag": "abcd123",
  "id": "/subscriptions/12345678-1234-1234-1234-123456789098/resourceGroups/kustorptest/providers/Microsoft.Kusto/Clusters/kustoCluster",
  "identity": {
    "type": "SystemAssigned",
    "principalId": "faabad1f-4876-463c-af9d-6ba2d2d2394c",
    "tenantId": "b932977f-6277-4ab7-a2cd-5bd21f07aaf4",
    "userAssignedIdentities": {}
  },
  "location": "westus",
  "properties": {
    "allowedIpRangeList": [
      "0.0.0.0/0"
    ],
    "enableAutoStop": true,
    "enableDiskEncryption": false,
    "enableDoubleEncryption": false,
    "enablePurge": true,
    "enableStreamingIngest": true,
    "engineType": "V3",
    "keyVaultProperties": {
      "keyName": "keyName",
      "keyVaultUri": "https://dummy.keyvault.com",
      "keyVersion": "keyVersion"
    },
    "languageExtensions": {
      "value": [
        {
          "languageExtensionImageName": "Python3_10_8",
          "languageExtensionName": "PYTHON"
        },
        {
          "languageExtensionImageName": "R",
          "languageExtensionName": "R"
        }
      ]
    },
    "provisioningState": "Succeeded",
    "publicIPType": "DualStack",
    "publicNetworkAccess": "Enabled",
    "restrictOutboundNetworkAccess": "Disabled"
  },
  "sku": {
    "name": "Standard_L16as_v3",
    "capacity": 2,
    "tier": "Standard"
  }
}

Definitions

Name Description
AcceptedAudiences

Represents an accepted audience trusted by the cluster.

AzureSku

Azure SKU definition.

AzureSkuName

SKU name.

AzureSkuTier

SKU tier.

CalloutPolicy

Configuration for external callout policies, including URI patterns, access types, and service types.

CalloutType

Type of the callout service, specifying the kind of external resource or service being accessed.

Cluster

Class representing a Kusto cluster.

ClusterNetworkAccessFlag

Whether or not to restrict outbound network access. Value is optional but if passed in, must be 'Enabled' or 'Disabled'

ComponentsSgqdofSchemasIdentityPropertiesUserassignedidentitiesAdditionalproperties
createdByType

The type of identity that created the resource.

EngineType

The engine type

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

Identity

Identity for the resource.

IdentityType

The type of managed identity used. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user-assigned identities. The type 'None' will remove all identities.

KeyVaultProperties

Properties of the key vault.

LanguageExtension

The language extension object.

LanguageExtensionImageName

Language extension image name.

LanguageExtensionName

Language extension that can run within KQL query.

LanguageExtensionsList

The list of language extension objects.

MigrationClusterProperties

Represents a properties of a cluster that is part of a migration.

MigrationClusterRole

The role of the cluster in the migration process.

OptimizedAutoscale

A class that contains the optimized auto scale definition.

OutboundAccess

Indicates whether outbound access is permitted for the specified URI pattern.

PrivateEndpointConnection

A private endpoint connection

PrivateEndpointProperty

Private endpoint which the connection belongs to.

PrivateLinkServiceConnectionStateProperty

Connection State of the Private Endpoint Connection.

ProvisioningState

The provisioned state of the resource.

PublicIPType

Indicates what public IP type to create - IPv4 (default), or DualStack (both IPv4 and IPv6)

PublicNetworkAccess

Public network access to the cluster is enabled by default. When disabled, only private endpoint connection to the cluster is allowed

State

The state of the resource.

systemData

Metadata pertaining to creation and last modification of the resource.

TrustedExternalTenant

Represents a tenant ID that is trusted by the cluster.

VirtualNetworkConfiguration

A class that contains virtual network definition.

VnetState

When enabled, the cluster is deployed into the configured subnet, when disabled it will be removed from the subnet.

ZoneStatus

Indicates whether the cluster is zonal or non-zonal.

AcceptedAudiences

Represents an accepted audience trusted by the cluster.

Name Type Description
value

string

GUID or valid URL representing an accepted audience.

AzureSku

Azure SKU definition.

Name Type Description
capacity

integer (int32)

The number of instances of the cluster.

name

AzureSkuName

SKU name.

tier

AzureSkuTier

SKU tier.

AzureSkuName

SKU name.

Value Description
Dev(No SLA)_Standard_D11_v2

Dev(No SLA)_Standard_D11_v2

Dev(No SLA)_Standard_E2a_v4

Dev(No SLA)_Standard_E2a_v4

Standard_D11_v2

Standard_D11_v2

Standard_D12_v2

Standard_D12_v2

Standard_D13_v2

Standard_D13_v2

Standard_D14_v2

Standard_D14_v2

Standard_D32d_v4

Standard_D32d_v4

Standard_D16d_v5

Standard_D16d_v5

Standard_D32d_v5

Standard_D32d_v5

Standard_DS13_v2+1TB_PS

Standard_DS13_v2+1TB_PS

Standard_DS13_v2+2TB_PS

Standard_DS13_v2+2TB_PS

Standard_DS14_v2+3TB_PS

Standard_DS14_v2+3TB_PS

Standard_DS14_v2+4TB_PS

Standard_DS14_v2+4TB_PS

Standard_L4s

Standard_L4s

Standard_L8s

Standard_L8s

Standard_L16s

Standard_L16s

Standard_L8s_v2

Standard_L8s_v2

Standard_L16s_v2

Standard_L16s_v2

Standard_L8s_v3

Standard_L8s_v3

Standard_L16s_v3

Standard_L16s_v3

Standard_L32s_v3

Standard_L32s_v3

Standard_L8as_v3

Standard_L8as_v3

Standard_L16as_v3

Standard_L16as_v3

Standard_L32as_v3

Standard_L32as_v3

Standard_E64i_v3

Standard_E64i_v3

Standard_E80ids_v4

Standard_E80ids_v4

Standard_E2a_v4

Standard_E2a_v4

Standard_E4a_v4

Standard_E4a_v4

Standard_E8a_v4

Standard_E8a_v4

Standard_E16a_v4

Standard_E16a_v4

Standard_E8as_v4+1TB_PS

Standard_E8as_v4+1TB_PS

Standard_E8as_v4+2TB_PS

Standard_E8as_v4+2TB_PS

Standard_E16as_v4+3TB_PS

Standard_E16as_v4+3TB_PS

Standard_E16as_v4+4TB_PS

Standard_E16as_v4+4TB_PS

Standard_E8as_v5+1TB_PS

Standard_E8as_v5+1TB_PS

Standard_E8as_v5+2TB_PS

Standard_E8as_v5+2TB_PS

Standard_E16as_v5+3TB_PS

Standard_E16as_v5+3TB_PS

Standard_E16as_v5+4TB_PS

Standard_E16as_v5+4TB_PS

Standard_E2ads_v5

Standard_E2ads_v5

Standard_E4ads_v5

Standard_E4ads_v5

Standard_E8ads_v5

Standard_E8ads_v5

Standard_E16ads_v5

Standard_E16ads_v5

Standard_EC8as_v5+1TB_PS

Standard_EC8as_v5+1TB_PS

Standard_EC8as_v5+2TB_PS

Standard_EC8as_v5+2TB_PS

Standard_EC16as_v5+3TB_PS

Standard_EC16as_v5+3TB_PS

Standard_EC16as_v5+4TB_PS

Standard_EC16as_v5+4TB_PS

Standard_EC8ads_v5

Standard_EC8ads_v5

Standard_EC16ads_v5

Standard_EC16ads_v5

Standard_E8s_v4+1TB_PS

Standard_E8s_v4+1TB_PS

Standard_E8s_v4+2TB_PS

Standard_E8s_v4+2TB_PS

Standard_E16s_v4+3TB_PS

Standard_E16s_v4+3TB_PS

Standard_E16s_v4+4TB_PS

Standard_E16s_v4+4TB_PS

Standard_E8s_v5+1TB_PS

Standard_E8s_v5+1TB_PS

Standard_E8s_v5+2TB_PS

Standard_E8s_v5+2TB_PS

Standard_E16s_v5+3TB_PS

Standard_E16s_v5+3TB_PS

Standard_E16s_v5+4TB_PS

Standard_E16s_v5+4TB_PS

Standard_E2d_v4

Standard_E2d_v4

Standard_E4d_v4

Standard_E4d_v4

Standard_E8d_v4

Standard_E8d_v4

Standard_E16d_v4

Standard_E16d_v4

Standard_E2d_v5

Standard_E2d_v5

Standard_E4d_v5

Standard_E4d_v5

Standard_E8d_v5

Standard_E8d_v5

Standard_E16d_v5

Standard_E16d_v5

AzureSkuTier

SKU tier.

Value Description
Basic

Basic

Standard

Standard

CalloutPolicy

Configuration for external callout policies, including URI patterns, access types, and service types.

Name Type Description
calloutId

string

Unique identifier for the callout configuration.

calloutType

CalloutType

Type of the callout service, specifying the kind of external resource or service being accessed.

calloutUriRegex

string

Regular expression or FQDN pattern for the callout URI.

outboundAccess

OutboundAccess

Indicates whether outbound access is permitted for the specified URI pattern.

CalloutType

Type of the callout service, specifying the kind of external resource or service being accessed.

Value Description
kusto

kusto

sql

sql

cosmosdb

cosmosdb

external_data

external_data

azure_digital_twins

azure_digital_twins

sandbox_artifacts

sandbox_artifacts

webapi

webapi

mysql

mysql

postgresql

postgresql

genevametrics

genevametrics

azure_openai

azure_openai

Cluster

Class representing a Kusto cluster.

Name Type Default value Description
etag

string

"If etag is provided in the response body, it may also be provided as a header per the normal etag convention. Entity tags are used for comparing two or more entities from the same requested resource. HTTP/1.1 uses entity tags in the etag (section 14.19), If-Match (section 14.24), If-None-Match (section 14.26), and If-Range (section 14.27) header fields.")

id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

identity

Identity

The identity of the cluster, if configured.

location

string

The geo-location where the resource lives

name

string

The name of the resource

properties.acceptedAudiences

AcceptedAudiences[]

The cluster's accepted audiences.

properties.allowedFqdnList

string[]

List of allowed FQDNs(Fully Qualified Domain Name) for egress from Cluster.

properties.allowedIpRangeList

string[]

The list of ips in the format of CIDR allowed to connect to the cluster.

properties.calloutPolicies

CalloutPolicy[]

List of callout policies for egress from Cluster.

properties.dataIngestionUri

string

The cluster data ingestion URI.

properties.enableAutoStop

boolean

True

A boolean value that indicates if the cluster could be automatically stopped (due to lack of data or no activity for many days).

properties.enableDiskEncryption

boolean

False

A boolean value that indicates if the cluster's disks are encrypted.

properties.enableDoubleEncryption

boolean

False

A boolean value that indicates if double encryption is enabled.

properties.enablePurge

boolean

False

A boolean value that indicates if the purge operations are enabled.

properties.enableStreamingIngest

boolean

False

A boolean value that indicates if the streaming ingest is enabled.

properties.engineType

EngineType

V3

The engine type

properties.keyVaultProperties

KeyVaultProperties

KeyVault properties for the cluster encryption.

properties.languageExtensions

LanguageExtensionsList

List of the cluster's language extensions.

properties.migrationCluster

MigrationClusterProperties

Properties of the peer cluster involved in a migration to/from this cluster.

properties.optimizedAutoscale

OptimizedAutoscale

Optimized auto scale definition.

properties.privateEndpointConnections

PrivateEndpointConnection[]

A list of private endpoint connections.

properties.provisioningState

ProvisioningState

The provisioned state of the resource.

properties.publicIPType

PublicIPType

IPv4

Indicates what public IP type to create - IPv4 (default), or DualStack (both IPv4 and IPv6)

properties.publicNetworkAccess

PublicNetworkAccess

Enabled

Public network access to the cluster is enabled by default. When disabled, only private endpoint connection to the cluster is allowed

properties.restrictOutboundNetworkAccess

ClusterNetworkAccessFlag

Disabled

Whether or not to restrict outbound network access. Value is optional but if passed in, must be 'Enabled' or 'Disabled'

properties.state

State

The state of the resource.

properties.stateReason

string

The reason for the cluster's current state.

properties.trustedExternalTenants

TrustedExternalTenant[]

The cluster's external tenants.

properties.uri

string

The cluster URI.

properties.virtualClusterGraduationProperties

string (password)

Virtual Cluster graduation properties

properties.virtualNetworkConfiguration

VirtualNetworkConfiguration

Virtual network definition.

properties.zoneStatus

ZoneStatus

Indicates whether the cluster is zonal or non-zonal.

sku

AzureSku

The SKU of the cluster.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

tags

object

Resource tags.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

zones

string[]

The availability zones.

ClusterNetworkAccessFlag

Whether or not to restrict outbound network access. Value is optional but if passed in, must be 'Enabled' or 'Disabled'

Value Description
Enabled

Enabled

Disabled

Disabled

ComponentsSgqdofSchemasIdentityPropertiesUserassignedidentitiesAdditionalproperties

Name Type Description
clientId

string

The client id of user assigned identity.

principalId

string

The principal id of user assigned identity.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

EngineType

The engine type

Value Description
V2

V2

V3

V3

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

Identity

Identity for the resource.

Name Type Description
principalId

string

The principal ID of resource identity.

tenantId

string

The tenant ID of resource.

type

IdentityType

The type of managed identity used. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user-assigned identities. The type 'None' will remove all identities.

userAssignedIdentities

<string,  ComponentsSgqdofSchemasIdentityPropertiesUserassignedidentitiesAdditionalproperties>

The list of user identities associated with the Kusto cluster. The user identity dictionary key references will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}'.

IdentityType

The type of managed identity used. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user-assigned identities. The type 'None' will remove all identities.

Value Description
None

None

SystemAssigned

SystemAssigned

UserAssigned

UserAssigned

SystemAssigned, UserAssigned

SystemAssigned, UserAssigned

KeyVaultProperties

Properties of the key vault.

Name Type Description
federatedIdentityClientId

string

The application (client) ID of the multi-tenant Microsoft Entra application. Used for cross-tenant customer-managed key scenarios where the encryption key is stored in a different tenant than the cluster. The application must be configured with the user-assigned managed identity as a federated identity credential.

keyName

string

The name of the key vault key.

keyVaultUri

string

The Uri of the key vault.

keyVersion

string

The version of the key vault key.

userIdentity

string

The user assigned identity (ARM resource id) that has access to the key. The identity must have 'Get', 'Wrap Key', and 'Unwrap Key' permissions on the Key Vault key, or be assigned the 'Key Vault Crypto Service Encryption User' role.

LanguageExtension

The language extension object.

Name Type Description
languageExtensionCustomImageName

string

The sandbox custom image name that should be enabled as the active language extension. Sandbox custom image is a cluster sub resource. When this property is set, LanguageExtensionImageName should be set to 'PythonCustomImage'.

languageExtensionImageName

LanguageExtensionImageName

The language extension image name.

languageExtensionName

LanguageExtensionName

The language extension name.

LanguageExtensionImageName

Language extension image name.

Value Description
R

R

Python3_6_5

Python3_6_5

Python3_10_8

Python3_10_8

Python3_10_8_DL

Python3_10_8_DL

PythonCustomImage

PythonCustomImage

Python3_11_7

Python3_11_7

Python3_11_7_DL

Python3_11_7_DL

LanguageExtensionName

Language extension that can run within KQL query.

Value Description
PYTHON

PYTHON

R

R

LanguageExtensionsList

The list of language extension objects.

Name Type Description
nextLink

string

The link to the next page of resources.

value

LanguageExtension[]

The list of language extensions.

MigrationClusterProperties

Represents a properties of a cluster that is part of a migration.

Name Type Description
dataIngestionUri

string

The public data ingestion URL of the cluster.

id

string

The resource ID of the cluster.

role

MigrationClusterRole

The role of the cluster in the migration process.

uri

string

The public URL of the cluster.

MigrationClusterRole

The role of the cluster in the migration process.

Value Description
Source

Source

Destination

Destination

OptimizedAutoscale

A class that contains the optimized auto scale definition.

Name Type Description
isEnabled

boolean

A boolean value that indicate if the optimized autoscale feature is enabled or not.

maximum

integer (int32)

Maximum allowed instances count.

minimum

integer (int32)

Minimum allowed instances count.

version

integer (int32)

The version of the template defined, for instance 1.

OutboundAccess

Indicates whether outbound access is permitted for the specified URI pattern.

Value Description
Allow

Allow

Deny

Deny

PrivateEndpointConnection

A private endpoint connection

Name Type Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

name

string

The name of the resource

properties.groupId

string

Group id of the private endpoint.

properties.privateEndpoint

PrivateEndpointProperty

Private endpoint which the connection belongs to.

properties.privateLinkServiceConnectionState

PrivateLinkServiceConnectionStateProperty

Connection State of the Private Endpoint Connection.

properties.provisioningState

string

Provisioning state of the private endpoint.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

PrivateEndpointProperty

Private endpoint which the connection belongs to.

Name Type Description
id

string

Resource id of the private endpoint.

PrivateLinkServiceConnectionStateProperty

Connection State of the Private Endpoint Connection.

Name Type Description
actionsRequired

string

Any action that is required beyond basic workflow (approve/ reject/ disconnect)

description

string

The private link service connection description.

status

string

The private link service connection status.

ProvisioningState

The provisioned state of the resource.

Value Description
Running

Running

Creating

Creating

Deleting

Deleting

Succeeded

Succeeded

Failed

Failed

Moving

Moving

Canceled

Canceled

PublicIPType

Indicates what public IP type to create - IPv4 (default), or DualStack (both IPv4 and IPv6)

Value Description
IPv4

IPv4

DualStack

DualStack

PublicNetworkAccess

Public network access to the cluster is enabled by default. When disabled, only private endpoint connection to the cluster is allowed

Value Description
Enabled

Enabled

Disabled

Disabled

SecuredByPerimeter

SecuredByPerimeter

State

The state of the resource.

Value Description
Creating

Creating

Unavailable

Unavailable

Running

Running

Deleting

Deleting

Deleted

Deleted

Stopping

Stopping

Stopped

Stopped

Starting

Starting

Updating

Updating

Migrated

Migrated

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.

TrustedExternalTenant

Represents a tenant ID that is trusted by the cluster.

Name Type Description
value

string

GUID representing an external tenant.

VirtualNetworkConfiguration

A class that contains virtual network definition.

Name Type Default value Description
dataManagementPublicIpId

string

Data management's service public IP address resource id.

enginePublicIpId

string

Engine service's public IP address resource id.

state

VnetState

Enabled

When enabled, the cluster is deployed into the configured subnet, when disabled it will be removed from the subnet.

subnetId

string

The subnet resource id.

VnetState

When enabled, the cluster is deployed into the configured subnet, when disabled it will be removed from the subnet.

Value Description
Enabled

Enabled

Disabled

Disabled

ZoneStatus

Indicates whether the cluster is zonal or non-zonal.

Value Description
NonZonal

NonZonal

ZonalInconsistency

ZonalInconsistency

Zonal

Zonal